// ------------------------------------------------------------------------------------
// irr::core::array<u32> wrappers
// NOTES:
// did not wrap the const version of getLast()
// ------------------------------------------------------------------------------------

extern "C" array<u32>* IrrCore_Array_u32_new()
{
	return new array<u32>();
}

extern "C" array<u32>* IrrCore_Array_u32_newWithSize(u32 start_count)
{
	return new array<u32>(start_count);
}

extern "C" array<u32>* IrrCore_Array_u32_newFromOther(array<u32>* other)
{
	return new array<u32>(*other);
}

extern "C" void IrrCore_Array_u32_del(array<u32>* arr)
{
	if (arr)
		delete arr;
		
	arr=0;
}

extern "C" u32 IrrCore_Array_u32_allocated_size(array<u32>* arr)
{
	if (arr)
		return arr->allocated_size();
	else
		return 0;
}

extern "C" void IrrCore_Array_u32_clear(array<u32>* arr)
{
	if (arr)
		arr->clear();
}

extern "C" const u32* IrrCore_Array_u32_const_pointer(array<u32>* arr)
{
	if (arr)
		arr->const_pointer();
}

extern "C" u32* IrrCore_Array_u32_pointer(array<u32>* arr)
{
	if (arr)
		arr->pointer();
}

extern "C" bool IrrCore_Array_u32_empty(array<u32>* arr)
{
	if (arr)
		return arr->empty();
	else
		return true;
}

extern "C" void IrrCore_Array_u32_eraseWithCount(array<u32>* arr,u32 idx,s32 count)
{
	if (arr)
		arr->erase(idx,count);
}

extern "C" void IrrCore_Array_u32_erase(array<u32>* arr,u32 idx)
{
	if (arr)
		arr->erase(idx);
}

// do not delete this pointer
extern "C" u32* IrrCore_Array_u32_getLast(array<u32>* arr)
{
	if (arr)
		return &arr->getLast();
	else
		return 0;
}

// do not delete this pointer
extern "C" u32* IrrCore_Array_u32_elementAt(array<u32>* arr,u32 idx)
{
	if (arr)
		return &(*arr)[idx];
	else
		return 0;
}

extern "C" void IrrCore_Array_u32_insert(array<u32>* arr,u32* element,u32 idx=0)
{
	if (arr)
		arr->insert(*element,idx);
}

extern "C" void IrrCore_Array_u32_Eq(array<u32>* arr,array<u32>* other)
{
	if (arr)
		*arr=*other;
}

extern "C" void IrrCore_Array_u32_push_back(array<u32>* arr,u32* element)
{
	if (arr)
		arr->push_back(*element);
}

extern "C" void IrrCore_Array_u32_push_front(array<u32>* arr,u32* element)
{
	if (arr)
		arr->push_front(*element);
}

extern "C" void IrrCore_Array_u32_reallocate(array<u32>* arr,u32 new_size)
{
	if (arr)
		arr->reallocate(new_size);
}

extern "C" void IrrCore_Array_u32_set_free_when_destroyed(array<u32>* arr,bool f)
{
	if (arr)
		arr->set_free_when_destroyed(f);
}

extern "C" void IrrCore_Array_u32_set_pointer(array<u32>* arr,u32 newPointer[],u32 size)
{
	if (arr)
		arr->set_pointer(newPointer,size);
}

extern "C" void IrrCore_Array_u32_set_sorted(array<u32>* arr,bool bVal)
{
	if (arr)
		arr->set_sorted(bVal);
}

extern "C" void IrrCore_Array_u32_set_used(array<u32>* arr,bool bVal)
{
	if (arr)
		arr->set_used(bVal);
}

extern "C" s32 IrrCore_Array_u32_size(array<u32>* arr)
{
	if (arr)
		return arr->size();
	else
		return 0;
}

extern "C" s32 IrrCore_Array_u32_linear_reverse_search(array<u32>* arr,u32* find)
{
	if (arr)
		return arr->linear_reverse_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_u32_linear_search(array<u32>* arr,u32* find)
{
	if (arr)
		return arr->linear_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_u32_binary_search(array<u32>* arr,u32* find)
{
	if (arr)
		return arr->binary_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_u32_binary_searchWithBounds(array<u32>* arr,u32* find,s32 left,s32 right)
{
	if (arr)
		return arr->binary_search(*find,left,right);
	else
		return -1;
}

extern "C" void IrrCore_Array_u32_sort(array<u32>* arr)
{
	if (arr)
		arr->sort();
}



